# Statuspage Resource Provider

The Statuspage Resource Provider lets you manage [Statuspage](http://statuspage.io) resources.

## Installing

This package is available for several languages/platforms:

### Node.js (JavaScript/TypeScript)

To use from JavaScript or TypeScript in Node.js, install using either `npm`:

```bash
npm install pulumi-statuspage
```

or `yarn`:

```bash
yarn add pulumi-statuspage
```

### Python

To use from Python, install using `pip`:

```bash
pip install pulumi_statuspage
```

### Go

To use from Go, use `go get` to grab the latest version of the library:

```bash
go get github.com/mortaelth/pulumi-statuspage-provider/sdk/go/...
```

### .NET

To use from .NET, install using `dotnet add package`:

```bash
dotnet add package statuspage
```

## Configuration

The following configuration points are available for the `statuspage` provider:

- `statuspage:token` (environment: `STATUSPAGE_TOKEN`) - the API key for your `statuspage.io` instance

## Reference

For detailed reference documentation, please visit [the Pulumi registry](https://www.pulumi.com/registry/packages/statuspage/api-docs/).
